﻿@page
@model BeamAndGo.Member.Admin.Web.Pages.Member.PreferenceModel
@{
    ViewData["Title"] = "Preferences";
    if (Model.IsXHR) Layout = null;
    else Layout = "_Layout";
}

<style>
    .uk-switch {
        position: relative;
        display: inline-block;
        height: 34px;
        width: 60px;
    }
        /*Hide default HTML checkbox*/
        .uk-switch input {
            display: none;
        }
    /* Slider */
    .uk-switch-slider {
        background-color: rgba(0,0,0,0.22);
        position: absolute;
        top: 0;
        left: 0;
        right: 0;
        border-radius: 500px;
        bottom: 0;
        cursor: pointer;
        transition-property: background-color;
        transition-duration: .2s;
        box-shadow: inset 0 0 2px rgba(0,0,0,0.07);
    }
        /* Switch pointer */
        .uk-switch-slider:before {
            content: '';
            background-color: #fff;
            position: absolute;
            width: 30px;
            height: 30px;
            left: 2px;
            bottom: 2px;
            border-radius: 50%;
            transition-property: transform, box-shadow;
            transition-duration: .2s;
        }
    /* Slider active color */
    input:checked + .uk-switch-slider {
        background-color: #39f !important;
    }
        /* Pointer active animation */
        input:checked + .uk-switch-slider:before {
            transform: translateX(26px);
        }
</style>

<div class="@(!Model.IsXHR ? "uk-container" : "")">
    <div class="@(!Model.IsXHR ? "uk-flex-center uk-grid" : "")">
        <div class="@(!Model.IsXHR ? "uk-width-2-3@s" : "")">

            <form class="uk-form-stacked" id="form-preference" asp-antiforgery="true" method="post"  asp-page-handler="UpdatePreference" data-ajax="true" data-ajax-method="post" data-ajax-success="updatePreferenceSuccess" data-ajax-failure="updatePreferenceFailed" novalidate>
                <div class="@(!Model.IsXHR ? "uk-card uk-card-default uk-card-small uk-card-body" : "") uk-width-1-1@m">
                    <h3>Preferences</h3>
                    <input type="hidden" asp-for="SelectedMemberSid" value="@Model.SelectedMemberSid">
                    @await foreach (var memberPreference in Model.MemberPreferences)
                    {
                        <div class="uk-margin-small uk-grid-small" uk-grid>
                            <input type="hidden" id="PreferenceTypeId" asp-for="SelectedPreferenceTypeId" />
                            <input type="hidden" id="MemberPreferenceValue" asp-for="CurrentSelectedValue" />

                            <div class="uk-width-auto">
                                <input type="checkbox" id="@memberPreference.PreferenceTypeId" class="uk-checkbox preference-checked" @(memberPreference.Value.ToLower() == "true" ? "checked" : "")
                                       SelectedPreferenceTypeId="@memberPreference.PreferenceTypeId">
                            </div>
                            <div class="uk-width-expand">
                                <label class="uk-text-bold"> @memberPreference.PreferenceType.Name</label>
                                <p class="uk-margin-remove">@memberPreference.PreferenceType.Description</p>
                            </div>
                        </div>
                    }
                </div>
            </form>
        </div>
    </div>
</div>

<script>
    $('.preference-checked').click(function () {
        $('#PreferenceTypeId').val($(this).attr('SelectedPreferenceTypeId'));

        if ($('#' + $(this).attr('SelectedPreferenceTypeId')).is(':checked')) {
            $('#MemberPreferenceValue').val("true");
        } else {
            $('#MemberPreferenceValue').val("false");
        }

        $("#form-preference").submit();
    });

    updatePreferenceSuccess = (xhr) => {
        showSuccessNotification(xhr);
    };
    updatePreferenceFailed = (xhr) => {
        showErrorNotification(xhr.responseText);
    };
</script>